package echo;

import com.sun.grizzly.tcp.Adapter;
import com.sun.grizzly.tcp.InputBuffer;
import com.sun.grizzly.tcp.OutputBuffer;
import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.tcp.Response;
import com.sun.grizzly.util.buf.ByteChunk;

/**
 * Send back syncronously the payload that he receive.
 */
public class EchoAdapter implements Adapter
{
	@Override
	public void service( Request request, Response response ) throws Exception
	{
		InputBuffer in = request.getInputBuffer();
		OutputBuffer out = response.getOutputBuffer();

		response.setStatus( 200 );

		ByteChunk chunk = new ByteChunk( 1024 );
		
		String str = "##Echo_Top\n";
		chunk.append( str.getBytes(), 0, str.length() );
		out.doWrite( chunk, response );

		while (in.doRead( chunk, request ) > 0)
		{
			out.doWrite( chunk, response );
		}

		str = "##Echo_Bottom\n";
		chunk.append( str.getBytes(), 0, str.length() );
		out.doWrite( chunk, response );
	}

	@Override
	public void afterService( Request request, Response response ) throws Exception
	{
		request.recycle();
		response.recycle();
	}
}
